package com.aquahopper.suna.lib.util;

/*
ObjectHash.java : HashTable extended.
Copyright (C) 2000, Sunagawa Youichi <suna@love.email.ne.jp>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

import	java.util.*;

public class ObjectHash extends java.util.Hashtable 
{
	private	ObjectHashCompProc	ohCompproc	=	null;
	private	Hashtable			ohKeys		=	null;
	private	Object				ohOrder[]	=	null;
	private	boolean				ohIntegrity	=	false;
	private	int					ohCurIndex	=	0;
public ObjectHash()
{
	super();
	this._initialize();
}
public ObjectHash(int initialCapacity)
{
	super(initialCapacity);
	this._initialize();
}
public ObjectHash(int initialCapacity, float loadFactor)
{
	super(initialCapacity, loadFactor);
	this._initialize();
}
private void _initialize()
{
	ohCompproc	=	new ObjectHashCompProc();
	ohKeys		=	null;
	ohOrder		=	null;
	ohIntegrity	=	false;
	ohCurIndex	=	-1;
}
 public synchronized void clear()
 {
	 this._initialize();
	 super.clear();
 }     
public Object ohFirst()
{
	if(! ohIntegrity){
		ohSort(ohCompproc);
	}
	return(ohNext());
}
public Object ohNext()
{
	Object oKey = null;
	if(! ohIntegrity){
		ohSort(ohCompproc);
	}
	
	if((ohCurIndex >= size())||(ohCurIndex < 0)){
		return(null);
	}
	else{
		oKey = ohOrder[ohCurIndex];
		++ohCurIndex;
	}
	return(oKey);
}
public Object ohPrev()
{
	Object oKey = null;
	if(! ohIntegrity){
		return(null);
	}
	else{
		if(ohCurIndex <= 0){
			return(null);
		}
		else{
			oKey = ohOrder[ohCurIndex];
			--ohCurIndex;
		}
	}
	return(oKey);
}
public void ohSort(ObjectHashCompProc	cp)
{
	ohIntegrity = true;
	ohCurIndex  = 0;
	
	if(size() == 0){
	}
	else{	//	size() > 2
		//	get keys
		ohOrder = new Object[size()];
		int i = 0;
		for(java.util.Enumeration e = keys(); e.hasMoreElements(); ){
			Object oKey = e.nextElement();
			ohOrder[i] = oKey;
			++i;
			//	Object oVal = get(oKey);
		}

		if(size() == 1){
			return;	//	There are nothing to do.
		}

		//	sort
		boolean	bScatterd = true;
		while(bScatterd){
			bScatterd = false;
			for(i = 0; i < size()-1 ; i++){
				Object	oTmp = null;
				int rcCompare = ohCompproc.compare(get(ohOrder[i]),get(ohOrder[i+1]));
				if(rcCompare > 0){
					bScatterd = true;
					oTmp = ohOrder[i+1];
					ohOrder[i+1] = ohOrder[i];
					ohOrder[i] = oTmp;
				}
				else if(rcCompare < 0){
					//	NOP
				}
				else{
					//	User proceduer has bugs. quit.
					return;
				}
			}
		}
	}
}
 public synchronized Object put(Object key,
								Object value)
 {
	 ohIntegrity	=	false;
	 return(super.put(key,value));
 }
 
 public synchronized Object remove(Object key)
 {
	 ohIntegrity	=	false;
	 return(super.remove(key));
 }   
}
